package infomat.vectorspace.weighting;

import infomat.vectorspace.*;
import infomat.vectorspace.ivector.*;
import infomat.vectorspace.similarity.*;

import mro.util.*;
import mro.util.properties.*;

import java.lang.Math.*;
import java.util.*;

/**
 * A class for weighting of a IMatrix. 
 *
 * Not yet working as intended.
 *
 * @version          081119
 * @author           Magnus Rosell
 */
public class SubtractionWeighter extends Weighter{

    private SparseISimilarity rowSimilarity=null;

    public SubtractionWeighter(){
	super();
    }

    public SubtractionWeighter(mro.util.properties.Properties properties){
	super(properties);
    }

    public mro.util.properties.Properties getDefaultProperties(){

	mro.util.properties.Properties properties = new mro.util.properties.Properties("Subtraction Weighter Properties", CurrentClassGetter.getClassName());

	/*
	try{
	    // Local row weight
	    Property p = new Property("Multiply with current weight", true, "Multiply with current weight");
	    PropertyValueDescription pvd = new PropertyValueDescription(true, "Do it.");
	    p.addValueDescription(pvd);
	    pvd = new PropertyValueDescription(false, "Do not do it.");
	    p.addValueDescription(pvd);
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	    */

	return properties;
    }

    public Object getPropertyValue(String name){
	return properties.getPropertyValue(name);
    }

    public void setProperty(String name, Object value) 
	throws PropertyNotFoundException{
	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
	this.properties=properties;
    }

    public String getWeighterName(){
	return "Subtraction Weighter";
    }

    
    public void setRowISimilarity(SparseISimilarity rowSimilarity){
	this.rowSimilarity=rowSimilarity;
    }


    /**
     * Weight the IMatrix (the whole matrix, 
     * which may be more than the current IObjectGroupings, the picture).
     * <br>
     * <br>
     * Does not work properly before #setRowISimilarity() is called.
     */
    public void weight(IMatrix matrix){ 

	if(rowSimilarity==null)
	    return;

	IObjectSet rowSet = matrix.getRowIObjectSet();

	IVector<IVectorIndex> avgRepr = 
	    rowSimilarity.getGroupRepresentation(rowSet);

	
	Vector cellVec = matrix.getAllCells();
	for(int i=0; i<cellVec.size(); i++){
	    IMatrixCell mc = (IMatrixCell) cellVec.get(i);
	    float w = mc.getWeight();
	    IObject cio = mc.getColumnIObject();
	    if(w<avgRepr.getValue((IVectorIndex)cio))
		matrix.removeCell(mc);
	}

	//	boolean row = true;
	//	Normalizer.normalizeMatrix(matrix, row);

	/*
	int rowsOrColumns = (Integer) getPropertyValue("Dimension");
	IObjectSet set = matrix.getRowIObjectSet();
	if(rowsOrColumns==1)
	    set = matrix.getColumnIObjectSet();

	Vector<IObject> ioVec = set.getOrdered();
	for(int i=0; i<ioVec.size(); i++){
	    IObject io = ioVec.get(i);
	    Vector cellVec = getCellsWith(io);
	    float totalCount = 0.0f;
	    for(int j=0; j<cellVec.size(); j++){
		IMatrixCell mc = (IMatrixCell) cellVec.get(j);
		totalCount += mc.getLocalCount();
	    }
	    for(int j=0; j<cellVec.size(); j++){
		IMatrixCell mc = (IMatrixCell) cellVec.get(j);
		mc.setWeight(mc.getLocalCount());
	    }
	}
	*/
    }
}
