package mro.util;

import java.io.*;

/**
 * A helper class. Some functions used when printing 
 * html-documents.
 *
 * @version          080418
 * @author           Magnus Rosell
 */
public class HTMLHelper{

    public static void printHTMLHead(PrintWriter pw, String title) throws IOException{
        pw.println("<html>");
	if(title!=null){
	    pw.println("<head>");
	    pw.println("<title>"+title+"<title>");
	    pw.println("</head>");
	}
    }

    public static void printHTMLLink(PrintWriter pw, String string, String location) throws IOException{

        pw.print("<a href="+location+">"+string+"</a>");
    }

    public static void printHTMLEnd(PrintWriter pw) throws IOException{
        pw.println("</html>");
    }
}
